diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
index a767038d4..b2b49bbc0 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
@@ -12,13 +12,13 @@ import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -30,12 +30,12 @@ import java.util.Map;
 public class SmeltingPage
     extends RecipePage<RecipeEntryFurnace> {
     public static final int RECIPES_PER_PAGE = 6;
-    public List<SlotGuidebook> slots;
-    public Map<RecipeEntryFurnace,List<SlotGuidebook>> map;
+    public List<GuidebookSlot> slots;
+    public Map<RecipeEntryFurnace,List<GuidebookSlot>> map;
     private final GuiTooltip guiTooltip;
     private final GuiRenderItem guiRenderItem;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
-    private static EntityPlayer player;
+    private static Player player;
     private static long ticks = 0;
     public SmeltingPage(GuidebookSection section, ArrayList<RecipeEntryFurnace> recipes) {
         super(section);
@@ -43,14 +43,14 @@ public class SmeltingPage
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
         player = mc.thePlayer;
-        player.addStat(AchievementList.OPEN_GUIDEBOOK,1);
+        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         guiTooltip = new GuiTooltip(mc);
         guiRenderItem = new GuiRenderItem(mc);
 
         for (RecipeEntryFurnace recipe : recipes) {
-            List<SlotGuidebook> recipeSlots = new ArrayList<>();
-            recipeSlots.add(new SlotGuidebook(0, (width/2)-32, 32*(map.size()+1)-16, recipe.getInput(), false,recipe));
-            recipeSlots.add(new SlotGuidebook(1, (width/2)+24, 32*(map.size()+1)-16, new RecipeSymbol(recipe.getOutput()), false,recipe));
+            List<GuidebookSlot> recipeSlots = new ArrayList<>();
+            recipeSlots.add(new GuidebookSlot(0, (width/2)-32, 32*(map.size()+1)-16, recipe.getInput(), false,recipe));
+            recipeSlots.add(new GuidebookSlot(1, (width/2)+24, 32*(map.size()+1)-16, new RecipeSymbol(recipe.getOutput()), false,recipe));
             map.put(recipe,recipeSlots);
             slots.addAll(recipeSlots);
         }
@@ -61,37 +61,37 @@ public class SmeltingPage
         if(recipes.isEmpty()){
             drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
         }
-        SlotGuidebook mouseOverSlot = null;
+        GuidebookSlot mouseOverSlot = null;
         ticks++;
-        for (SlotGuidebook slot : slots) {
+        for (GuidebookSlot slot : slots) {
             if(ticks > 150) {
                 slot.showRandomItem();
                 if(slots.get(slots.size()-1) == slot){
                     ticks = 0;
                 }
             }
-            drawSlot(re,x+slot.xDisplayPosition-1,y+slot.yDisplayPosition-1,0xFFFFFFFF);
+            drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            guiRenderItem.render(slot.getStack(),x+slot.xDisplayPosition,y+slot.yDisplayPosition,mouseOverSlot == slot,slot);
+            guiRenderItem.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
     public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY)
     {
-        return mouseX >= x+slot.xDisplayPosition - 1 && mouseX < x+slot.xDisplayPosition + 16 + 1 && mouseY >= y+slot.yDisplayPosition - 1 && mouseY < y+slot.yDisplayPosition + 16 + 1;
+        return mouseX >= x+slot.x - 1 && mouseX < x+slot.x + 16 + 1 && mouseY >= y+slot.y - 1 && mouseY < y+slot.y + 16 + 1;
     }
 
     @Override
     public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null){
-                if(hoveringSlot.hasStack()){
-                    String query = "r:"+hoveringSlot.getStack().getDisplayName()+"!";
+                if(hoveringSlot.hasItem()){
+                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -99,13 +99,13 @@ public class SmeltingPage
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null) {
-                if (hoveringSlot.hasStack()) {
-                    String query = "u:" + hoveringSlot.getStack().getDisplayName() + "!";
+                if (hoveringSlot.hasItem()) {
+                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -124,25 +124,25 @@ public class SmeltingPage
     @Override
     protected void renderBackground(RenderEngine re, int x, int y) {
         super.renderBackground(re, x, y);
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
+        re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         for (int i = 1; i <= recipes.size(); i++) {
             RecipeEntryFurnace recipe = recipes.get(i-1);
-            List<SlotGuidebook> list = map.get(recipe);
-            drawTexturedModalRect(x + list.get(list.size()-1).xDisplayPosition - 32, y +  list.get(list.size()-1).yDisplayPosition, 234, 0, 22, 15);
+            List<GuidebookSlot> list = map.get(recipe);
+            drawTexturedModalRect(x + list.get(list.size()-1).x - 32, y +  list.get(list.size()-1).y, 234, 0, 22, 15);
         }
     }
 
     @Override
     protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
-        SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
+        GuidebookSlot mouseOverSlot = null;
+        for (GuidebookSlot slot : slots) {
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (mouseOverSlot != null && mouseOverSlot.hasStack())
+            if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getStack(), showDescription, mouseOverSlot);
+                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     guiTooltip.render(str, mouseX, mouseY, 8, -8);
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
index e8c4dd3ed..30395d2c9 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
@@ -14,14 +14,14 @@ import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -33,12 +33,12 @@ import java.util.Map;
 public class TrommelPage
     extends RecipePage<RecipeEntryTrommel> {
     public static final int RECIPES_PER_PAGE = 3;
-    public List<SlotGuidebook> slots;
-    public Map<RecipeEntryTrommel,List<SlotGuidebook>> map;
+    public List<GuidebookSlot> slots;
+    public Map<RecipeEntryTrommel,List<GuidebookSlot>> map;
     private final GuiTooltip guiTooltip;
     private final GuiRenderItem guiRenderItem;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
-    private static EntityPlayer player;
+    private static Player player;
     private static long ticks = 0;
     private static long ticks2 = 0;
 
@@ -48,27 +48,27 @@ public class TrommelPage
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
         player = mc.thePlayer;
-        player.addStat(AchievementList.OPEN_GUIDEBOOK,1);
+        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         guiTooltip = new GuiTooltip(mc);
         guiRenderItem = new GuiRenderItem(mc);
         int recipeAmount = 0;
         int yOffset = 8;
         for (RecipeEntryTrommel recipe : recipes) {
-            List<SlotGuidebook> recipeSlots = new ArrayList<>();
+            List<GuidebookSlot> recipeSlots = new ArrayList<>();
             int slotsAmount = 10;
 
             for (int i = 0; i < slotsAmount - 1; i++)
             {
                 if(recipe.getOutput().getEntries().size() > i){
                     ItemStack stack = recipe.getOutput().getEntries().get(i).getItemStack();
-                    recipeSlots.add(new SlotGuidebook(i, 81 + 20 * (i % 3), 1 + 20 * ((i / 3)+recipeAmount*3) + yOffset, new RecipeSymbol(stack), false,recipe).setAsOutput());
+                    recipeSlots.add(new GuidebookSlot(i, 81 + 20 * (i % 3), 1 + 20 * ((i / 3)+recipeAmount*3) + yOffset, new RecipeSymbol(stack), false,recipe).setAsOutput());
                 } else {
-                    recipeSlots.add(new SlotGuidebook(i, 81 + 20 * (i % 3), 1 + 20 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe).setAsOutput());
+                    recipeSlots.add(new GuidebookSlot(i, 81 + 20 * (i % 3), 1 + 20 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe).setAsOutput());
                 }
             }
 
-            int centerY = (recipeSlots.get(recipeSlots.size()-1).yDisplayPosition + recipeSlots.get(recipeSlots.size()-8).yDisplayPosition) / 2;
-            recipeSlots.add(new SlotGuidebook(slotsAmount - 1, 19, centerY,recipe.getInput(), false,recipe));
+            int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
+            recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 19, centerY,recipe.getInput(), false,recipe));
 
             map.put(recipe,recipeSlots);
             slots.addAll(recipeSlots);
@@ -83,15 +83,15 @@ public class TrommelPage
         if(recipes.isEmpty()){
             drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
         }
-        SlotGuidebook mouseOverSlot = null;
+        GuidebookSlot mouseOverSlot = null;
         ticks++;
         ticks2++;
         if(ticks2 > 200) {
             ticks2 = 0;
-            for (SlotGuidebook slot : slots) {
+            for (GuidebookSlot slot : slots) {
                 if (slot.recipe instanceof RecipeEntryTrommel) {
                     RecipeSymbol input = (RecipeSymbol) slot.recipe.getInput();
-                    if (!input.matches(slot.getStack())) {
+                    if (!input.matches(slot.getItem())) {
                         if(slot.recipeAmount > 8){
                             int recipeIndexMax = Math.round((float) slot.recipeAmount /9);
                             if(slot.recipeIndex >= recipeIndexMax){
@@ -100,7 +100,7 @@ public class TrommelPage
                                 slot.recipeIndex++;
                             }
                             WeightedRandomBag<WeightedRandomLootObject> loot = (WeightedRandomBag<WeightedRandomLootObject>) slot.recipe.getOutput();
-                            int index = slot.id + (9 * slot.recipeIndex);
+                            int index = slot.index + (9 * slot.recipeIndex);
                             if(index > slot.recipeAmount){
                                 slot.item = null;
                             } else {
@@ -111,35 +111,35 @@ public class TrommelPage
                 }
             }
         }
-        for (SlotGuidebook slot : slots) {
+        for (GuidebookSlot slot : slots) {
             if(ticks > 150) {
                 slot.showRandomItem();
                 if(slots.get(slots.size()-1) == slot){
                     ticks = 0;
                 }
             }
-            drawSlot(re,x+slot.xDisplayPosition-1,y+slot.yDisplayPosition-1,0xFFFFFFFF);
+            drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            guiRenderItem.render(slot.getStack(),x+slot.xDisplayPosition,y+slot.yDisplayPosition,mouseOverSlot == slot,slot);
+            guiRenderItem.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
     public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY)
     {
-        return mouseX >= x+slot.xDisplayPosition - 1 && mouseX < x+slot.xDisplayPosition + 16 + 1 && mouseY >= y+slot.yDisplayPosition - 1 && mouseY < y+slot.yDisplayPosition + 16 + 1;
+        return mouseX >= x+slot.x - 1 && mouseX < x+slot.x + 16 + 1 && mouseY >= y+slot.y - 1 && mouseY < y+slot.y + 16 + 1;
     }
 
     @Override
     public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null){
-                if(hoveringSlot.hasStack()){
-                    String query = "r:"+hoveringSlot.getStack().getDisplayName()+"!";
+                if(hoveringSlot.hasItem()){
+                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -147,13 +147,13 @@ public class TrommelPage
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null) {
-                if (hoveringSlot.hasStack()) {
-                    String query = "u:" + hoveringSlot.getStack().getDisplayName() + "!";
+                if (hoveringSlot.hasItem()) {
+                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -172,25 +172,25 @@ public class TrommelPage
     @Override
     protected void renderBackground(RenderEngine re, int x, int y) {
         super.renderBackground(re, x, y);
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
+        re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         for (int i = 1; i <= recipes.size(); i++) {
             RecipeEntryTrommel recipe = recipes.get(i-1);
-            List<SlotGuidebook> list = map.get(recipe);
-            drawTexturedModalRect(x + list.get(list.size()-1).xDisplayPosition + 25, y +  list.get(list.size()-1).yDisplayPosition, 234, 0, 22, 15);
+            List<GuidebookSlot> list = map.get(recipe);
+            drawTexturedModalRect(x + list.get(list.size()-1).x + 25, y +  list.get(list.size()-1).y, 234, 0, 22, 15);
         }
     }
 
     @Override
     protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
-        SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
+        GuidebookSlot mouseOverSlot = null;
+        for (GuidebookSlot slot : slots) {
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (mouseOverSlot != null && mouseOverSlot.hasStack())
+            if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getStack(), showDescription, mouseOverSlot);
+                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     guiTooltip.render(str, mouseX, mouseY, 8, -8);
diff --git a/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
index fbf8a40bb..80905322f 100644
--- a/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
@@ -3,12 +3,20 @@ package net.minecraft.client.gui.hud;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
 
 public class ArmorBarComponent
     extends MovableHudComponent {
+    private final IconCoordinate armor_empty;
+    private final IconCoordinate armor_half;
+    private final IconCoordinate armor_full;
     public ArmorBarComponent(String key, Layout layout) {
         super(key, 81, 10, layout);
+        armor_empty = TextureRegistry.getTexture("minecraft:gui/hud/armor_empty");
+        armor_half = TextureRegistry.getTexture("minecraft:gui/hud/armor_half");
+        armor_full = TextureRegistry.getTexture("minecraft:gui/hud/armor_full");
     }
 
     @Override
@@ -23,7 +31,6 @@ public class ArmorBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int armorValue = mc.thePlayer.getPlayerProtectionAmount();
@@ -34,17 +41,17 @@ public class ArmorBarComponent
                 if (i * 2 + 1 < armorValue)
                 {
                     // Full armor icon
-                    gui.drawTexturedModalRect(xArmor, y, 34, 9, 9, 9);
+                    gui.drawGuiIcon(xArmor, y, 9, 9, armor_full);
                 }
                 if (i * 2 + 1 == armorValue)
                 {
                     // Half armor icon
-                    gui.drawTexturedModalRect(xArmor, y, 25, 9, 9, 9);
+                    gui.drawGuiIcon(xArmor, y, 9, 9, armor_half);
                 }
                 if (i * 2 + 1 > armorValue)
                 {
                     // Empty armor icon
-                    gui.drawTexturedModalRect(xArmor, y, 16, 9, 9, 9);
+                    gui.drawGuiIcon(xArmor, y, 9, 9, armor_empty);
                 }
             }
         }
@@ -57,7 +64,6 @@ public class ArmorBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int armorValue = 11;
@@ -66,17 +72,17 @@ public class ArmorBarComponent
             if (i * 2 + 1 < armorValue)
             {
                 // Full armor icon
-                gui.drawTexturedModalRect(xArmor, y, 34, 9, 9, 9);
+                gui.drawGuiIcon(xArmor, y, 9, 9, armor_full);
             }
             if (i * 2 + 1 == armorValue)
             {
                 // Half armor icon
-                gui.drawTexturedModalRect(xArmor, y, 25, 9, 9, 9);
+                gui.drawGuiIcon(xArmor, y, 9, 9, armor_half);
             }
             if (i * 2 + 1 > armorValue)
             {
                 // Empty armor icon
-                gui.drawTexturedModalRect(xArmor, y, 16, 9, 9, 9);
+                gui.drawGuiIcon(xArmor, y, 9, 9, armor_empty);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java b/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
index f228bde20..866703502 100644
--- a/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.hud;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
 
 public class CrosshairComponent
@@ -23,12 +24,11 @@ public class CrosshairComponent
 
         // Setup crosshair texture
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
 
         // Render crosshair
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_ONE_MINUS_DST_COLOR, GL11.GL_ONE_MINUS_SRC_COLOR);
-        gui.drawTexturedModalRect(x, y, 0, 0, 15, 15);
+        gui.drawGuiIcon(x, y, 15, 15, TextureRegistry.getTexture("minecraft:gui/hud/crosshair"));
         GL11.glDisable(GL11.GL_BLEND);
     }
 
@@ -39,9 +39,8 @@ public class CrosshairComponent
 
         // Setup crosshair texture
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
 
         // Render crosshair
-        gui.drawTexturedModalRect(x, y, 0, 0, 15, 15);
+        gui.drawGuiIcon(x, y, 15, 15, TextureRegistry.getTexture("minecraft:gui/hud/crosshair"));
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
index 1bfc5d1d9..f9a177ba9 100644
--- a/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.hud;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
 
 public class FireBarComponent
@@ -23,14 +24,13 @@ public class FireBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         float fire = (float) mc.thePlayer.remainingFireTicks / (float) mc.thePlayer.maxFireTicks;
         int fireBar = (int) Math.min(fire * 20,20);
 
         for (int i = 0; i < fireBar / 2; i++) {
-            gui.drawTexturedModalRect(x + i * 8, y, 0, 52, 9, 9);
+            gui.drawGuiIcon(x + i * 8, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
         }
     }
 
@@ -41,12 +41,11 @@ public class FireBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int fireBar = 11;
         for (int i = 0; i < fireBar / 2; i++) {
-            gui.drawTexturedModalRect(x + i * 8, y, 0, 52, 9, 9);
+            gui.drawGuiIcon(x + i * 8, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
         }
     }
 }
